package hhenson.core;

/**
 * Provides a mechansim to identify one or more objects.
 * The id can be both unique or a search id. A unique
 * id can return a reference to the associated object (assuming the
 * object exists or is reachable).
 * 
 * @author Howard Henson
 */
public interface ID extends Comparable, Cloneable {
	/**
 	 * Returns the object associated with this id object if possible.
 	 * If the object can't find the object for some reason then throws
 	 * an ObjectNotLocatedException. If the id is mulformed for fetching
 	 * a specific object the an InvalidIDException is thrown.
	 */
	public Object getObject() throws InvalidIDException, ObjectNotLocatedException;
}
