package hhenson.core;

import hhenson.core.ID;

/**
 * Idicates that the class implementing this interface is identifiable,
 * or contains a unique ID that can be deemed to be representative of this class.
 * 
 * @author Howard Henson
 */
public interface Identifiable {
	/**
	 * Returns the id associated with the object implementing
	 * this method.
	 * This ID should be uniquely identifiable within the system
	 * and able to return the object that this was obtained from.
	 */
	public ID getId();
}
