package hhenson.oodb.core;

import java.lang.ref.SoftReference;
import java.lang.ref.WeakReference;

import goodsjpi.*;
import hhenson.core.*;

/**
* @author Howard Henson
* @version 1.0
* @generator Enterprise Architect
* @created 19-Aug-2002 11:06:07
*/

public abstract class OodbIDImpl 
	extends Persistent
	implements ID {
	
	/**
	 * Provides a mechanism to cache the actual implementation
	 * object associated with this ID to improve
	 * performance of subsequent requests. But does so
	 * in a memory frendly way.
	 */	
	private transient SoftReference reference;

	/**
 	 * Returns the object associated with this id object if possible.
 	 * If the object can't find the object for some reason then throws
 	 * an ObjectNotLocatedException. If the id is mulformed for fetching
 	 * a specific object the an InvalidIDException is thrown.
 	 * This method is called if the object is not located in the object cache.
 	 * If the object is in the cache the object in the cache is returned.
	 */
	protected abstract Object fetchObjectFromDatabase() throws InvalidIDException, ObjectNotLocatedException;	

	public OodbIDImpl() {

	}

	/**
 	 * Returns the object associated with this id object if possible.
 	 * If the object can't find the object for some reason then throws
 	 * an ObjectNotLocatedException. If the id is mulformed for fetching
 	 * a specific object the an InvalidIDException is thrown.
	 */
	public Object getObject() throws InvalidIDException, ObjectNotLocatedException{
		Object rVal = (reference!=null)?reference.get():null;
		if( rVal == null ){
			rVal = fetchObjectFromDatabase();
			reference = new SoftReference(rVal);
		}
		return rVal;
	}

}