package hhenson.oodb.entity;

/**
 * Formats information belonging to the entity group of classes.
 * These include formatting Telephone numbers and addresses.
 * 
 * @author Howard Henson
 */
public class EntityFormatter {

	/**
	 * Constructor for EntityFormatter.
	 */
	private EntityFormatter() {
		super();
	}
	
	/**
	 * returns a new instance of an entity formatter.
	 * This needs to load standard values for the system.
	 */
	public static EntityFormatter newInstance(){
		return new EntityFormatter();
	}
	
	public String formatTelephoneNumber(TelephoneNumber telephoneNumber){
		return telephoneNumber.toString();
	}
	
	public void applyTelephoneNumberFormat(String format){
	}
	
	public String formatAddress(Address address){
		return address.toString();
	}
	
	public void applyAddressFormat(String format){
	}

}
