package hhenson.oodb.entity;

/**
 * Denotes invalid data has been passed to the object.
 * The object will one day hopefully contain meaningful
 * information to facilitate correction of the information.
 * @author Howard Henson
 */
public class InvalidData extends Exception {

	/**
	 * Constructor for InvalidData.
	 */
	public InvalidData() {
		super();
	}

	/**
	 * Constructor for InvalidData.
	 * @param message
	 */
	public InvalidData(String message) {
		super(message);
	}

	/**
	 * Constructor for InvalidData.
	 * @param message
	 * @param cause
	 */
	public InvalidData(String message, Throwable cause) {
		super(message, cause);
	}

	/**
	 * Constructor for InvalidData.
	 * @param cause
	 */
	public InvalidData(Throwable cause) {
		super(cause);
	}

}
