package hhenson.oodb.roles.employee;

import java.util.Map;

import goodsjpi.Persistent;

/**
 * The collection of historic salary information.
 * 
 * @author Howard Henson
 */
public class SalaryHistory extends Persistent {

	/**
	 * The date ordered collection of salary information
	 * collected.
	 */
	private Map salaryHistoryMap;

	/**
	 * Constructor for SalaryHistory.
	 */
	public SalaryHistory() {
		super();
	}

	/**
	 * Returns the salaryHistoryMap.
	 * @return Map
	 */
	public Map getSalaryHistoryMap() {
		return salaryHistoryMap;
	}

	/**
	 * Sets the salaryHistoryMap.
	 * @param salaryHistoryMap The salaryHistoryMap to set
	 */
	public void setSalaryHistoryMap(Map salaryHistoryMap) {
		this.salaryHistoryMap = salaryHistoryMap;
	}

	/**
	 * Sets the salaryHistoryMap.
	 * @param salaryHistoryMap The salaryHistoryMap to set
	 */
	public void addSalaryHistory(Object key, Object value) {
		salaryHistoryMap.put(key, value);
	}

	/**
	 * @see java.lang.Object#hashCode()
	 */
	public int hashCode() {
		return salaryHistoryMap.hashCode();
	}

	/**
	 * @see java.lang.Object#equals(Object)
	 */
	public boolean equals(Object obj) {
		if (obj instanceof SalaryHistory) {
			return salaryHistoryMap.equals(
				((SalaryHistory) obj).getSalaryHistoryMap());
		}
		return false;
	}

	/**
	 * @see java.lang.Object#toString()
	 */
	public String toString() {
		return super.toString();
	}

}
