package hhenson.oodb.services.ocache;

import java.util.Iterator;
import java.util.NoSuchElementException;

import javax.naming.Binding;
import javax.naming.Context;
import javax.naming.NameClassPair;
import javax.naming.NamingException;

import goodslib.PersistentHashMap;

import org.apache.avalon.excalibur.naming.AbstractNamingEnumeration;
import org.apache.avalon.excalibur.naming.Namespace;

/**
 * 
 * @author Howard Henson
 */
final public class OodbNamingEnumeration 
    extends AbstractNamingEnumeration
{
    protected PersistentHashMap m_bindings;
    protected Iterator m_names;
    protected boolean m_returnBindings;

    public OodbNamingEnumeration( final Context owner,
                                    final Namespace namespace,
                                    final PersistentHashMap bindings,
                                    final boolean returnBindings )
    {
        super( owner, namespace );
        m_returnBindings = returnBindings;
        m_bindings = bindings;
        m_names = m_bindings.keySet().iterator();
    }

    public boolean hasMoreElements()
    {
        return m_names.hasNext();
    }

    public Object next()
        throws NamingException
    {
        if( !hasMore() ) throw new NoSuchElementException();

        final String name = (String)m_names.next();
        Object object = m_bindings.get( name );

        if( !m_returnBindings )
        {
            return new NameClassPair( name, object.getClass().getName() );
        }
        else
        {
            return new Binding( name, resolve( name, object ) );
        }
    }

    public void close()
    {
        super.close();
        m_bindings = null;
    }
}
